// hlavickove subory *******************************************************
// systemove funkcie
#include <string.h>
// GL a GLU kniznica
#include <GL/gl.h>
#include <GL/glu.h>
// funkcie SDL kniznice
#include <SDL/SDL.h>

// .h subor
#include "mObjects.h"

GLUquadricObj *obj_quad; // kvadratik objekt

// konstruktor *************************************************************
mObjects::mObjects()
{
 t_a=0.0f; t_b=0.0f;
}

// destruktor **************************************************************
mObjects::~mObjects()
{

}

// definicia objektov - suradnicova sustava ********************************
void mObjects::obj_axis(GLfloat color)
{
 glBegin(GL_LINES);             // ciary
  glColor4f(color,0.0f,0.0f,1.0f);
  for (t_a=0.0f;t_a>-100.0f;t_a-=10.0f) {
   glVertex3f(-50.0f,0.0f,t_a);  // X
   glVertex3f(100.0f,0.0f,t_a);
  }

  glColor4f(0.0f,color,0.0f,1.0f);
  for (t_a=0.0f;t_a>-100.0f;t_a-=10.0f) {
   glVertex3f(0.0f,-50.0f,t_a);  // Y
   glVertex3f(0.0f,100.0f,t_a);
  }

  glColor4f(0.0f,0.0f,color,1.0f);
  for (t_a=0.0f;t_a<100.0f;t_a+=10.0f) {
   glVertex3f(t_a,0.0f,-100.0f); // Z
   glVertex3f(t_a,0.0f,  50.0f);
  }
 glEnd();
}

// definicia objektov - XZ sachovnica **************************************
void mObjects::obj_XZplane(GLfloat color)
{
 glColor4f(color,color,color,1.0f);
 glBegin(GL_LINES);             // ciary
  for (t_a=-50.0f;t_a<=50.0f;t_a+=5.0f) {
   glVertex3f(t_a,0.0f, 50.0f);  // X
   glVertex3f(t_a,0.0f,-50.0f);
  }
  for (t_a=50.0f;t_a>=-50.0f;t_a-=5.0f) {
   glVertex3f(-50.0f,0.0f,t_a); // Z
   glVertex3f( 50.0f,0.0f,t_a);
  }
 glEnd();
}

// definicia objektov - XZ fill sachovnica *********************************
void mObjects::obj_XZplane1(GLfloat color)
{
 glColor4f(color,color,color,1.0f);
 glBegin(GL_QUADS);             // plocha
  for (t_b=50.0f;t_b>-50.0f;t_b-=5.0f) {
   for (t_a=-50.0f;t_a<=50.0f;t_a+=5.0f) {
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a     ,0.0f,t_b);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a+5.0f,0.0f,t_b);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a+5.0f,0.0f,t_b-5.0f);
    glNormal3f(0.0f,1.0f,0.0f); glVertex3f(t_a     ,0.0f,t_b-5.0f);
   }
  }
 glEnd();
}

// definicia objektov - kocka biela ****************************************
void mObjects::obj_cube0(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f); // farba
 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);  // predna stena
  glVertex3f( size,-size,size);
  glVertex3f( size, size,size);
  glVertex3f(-size, size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glVertex3f(size,-size, size);   // prava stena
  glVertex3f(size,-size,-size);
  glVertex3f(size, size,-size);
  glVertex3f(size, size, size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glVertex3f( size,-size,-size);  // zadna stena
  glVertex3f(-size,-size,-size);
  glVertex3f(-size, size,-size);
  glVertex3f( size, size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glVertex3f(-size,-size,-size); // lava stena
  glVertex3f(-size,-size, size);
  glVertex3f(-size, size, size);
  glVertex3f(-size, size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glVertex3f(-size,-size,-size); // dolna stena
  glVertex3f( size,-size,-size);
  glVertex3f( size,-size, size);
  glVertex3f(-size,-size, size);

  glNormal3f(0.0f,1.0f,0.0f);
  glVertex3f(-size,size, size);   // horna stena
  glVertex3f( size,size, size);
  glVertex3f( size,size,-size);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka farebna **************************************
void mObjects::obj_cube1(GLfloat size)
{
 glBegin(GL_QUADS);               // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);   // predna stena
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);    // prava stena
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);   // zadna stena
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);  // lava stena
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(-size,-size,-size);  // dolna stena
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(size,-size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(size,-size,size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(-size,-size,size);

  glNormal3f(0.0f,1.0f,0.0f);
  glColor4f(1.0f,1.0f,1.0f,1.0f);
  glVertex3f(-size,size,size);    // horna stena
  glColor4f(0.0f,0.0f,1.0f,1.0f);
  glVertex3f(size,size,size);
  glColor4f(1.0f,0.0f,0.0f,1.0f);
  glVertex3f(size,size,-size);
  glColor4f(0.0f,1.0f,0.0f,1.0f);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka texturovana **********************************
void mObjects::obj_cube2(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f); // farba
 glBegin(GL_QUADS);              // kocka
  glNormal3f(0.0f,0.0f,1.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,size);  // predna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,size);

  glNormal3f(1.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(size,-size,size);   // prava stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(size,size,size);

  glNormal3f(0.0f,0.0f,-1.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(size,-size,-size);  // zadna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(-size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(-size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(size,size,-size);

  glNormal3f(-1.0f,0.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,-size); // lava stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(-size,-size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(-size,size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,-size);

  glNormal3f(0.0f,-1.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,-size,-size); // dolna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,-size,-size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,-size,size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,-size,size);

  glNormal3f(0.0f,1.0f,0.0f);
  glTexCoord2f(0.0f,0.0f);
  glVertex3f(-size,size,size);   // horna stena
  glTexCoord2f(1.0f,0.0f);
  glVertex3f(size,size,size);
  glTexCoord2f(1.0f,1.0f);
  glVertex3f(size,size,-size);
  glTexCoord2f(0.0f,1.0f);
  glVertex3f(-size,size,-size);
 glEnd();
}

// definicia objektov - kocka texturovana s normalou v kazdom vrchole ******
void mObjects::obj_cube2N(GLfloat size)
{
 glColor4f(1.0f,1.0f,1.0f,1.0f);  // farba
 glBegin(GL_QUADS);               // kocka
  glNormal3f(-0.577f,-0.577f,0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,size);   // predna stena
  glNormal3f( 0.577f,-0.577f,0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,-size,size);
  glNormal3f( 0.577f, 0.577f,0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size, size,size);
  glNormal3f(-0.577f, 0.577f,0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size, size,size);

  glNormal3f(0.577f,-0.577f, 0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(size,-size, size);   // prava stena
  glNormal3f(0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(size,-size,-size);
  glNormal3f(0.577f, 0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(size, size,-size);
  glNormal3f(0.577f, 0.577f, 0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(size, size, size);

  glNormal3f( 0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f( size,-size,-size); // zadna stena
  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(-size,-size,-size);
  glNormal3f(-0.577f, 0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(-size, size,-size);
  glNormal3f( 0.577f, 0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f( size, size,-size);

  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,-size); // lava stena
  glNormal3f(-0.577f,-0.577f, 0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f(-size,-size, size);
  glNormal3f(-0.577f, 0.577f, 0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f(-size, size, size);
  glNormal3f(-0.577f, 0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size, size,-size);

  glNormal3f(-0.577f,-0.577f,-0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,-size,-size); // dolna stena
  glNormal3f( 0.577f,-0.577f,-0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,-size,-size);
  glNormal3f( 0.577f,-0.577f, 0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size,-size, size);
  glNormal3f(-0.577f,-0.577f, 0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size,-size, size);

  glNormal3f(-0.577f,0.577f, 0.577f); glTexCoord2f(0.0f,0.0f); glVertex3f(-size,size, size);   // horna stena
  glNormal3f( 0.577f,0.577f, 0.577f); glTexCoord2f(1.0f,0.0f); glVertex3f( size,size, size);
  glNormal3f( 0.577f,0.577f,-0.577f); glTexCoord2f(1.0f,1.0f); glVertex3f( size,size,-size);
  glNormal3f(-0.577f,0.577f,-0.577f); glTexCoord2f(0.0f,1.0f); glVertex3f(-size,size,-size);
 glEnd();
}

// inicializacia skyboxu ***************************************************
int mObjects::obj_skybox_init(char *mydir)
{
 char *names[6]={"skyfront","skyback","skybottom","skytop","skyright","skyleft"};
 char filename[128];
 int i;

 // alokovanie miesta pre data textur
 SDL_Surface *TextureImage[6];

 // generovanie jedinecnych identifikatorov 6-tich textur
 glGenTextures(6,skybox_tex_id);

 // vytvorenie textur
 for (i=0;i<6;i++) {
  strcpy(filename,"data/"); strcat(filename,mydir); strcat(filename,"/");
  strcat(filename, names[i]); strcat(filename,".bmp");

  TextureImage[i]=SDL_LoadBMP(filename);

  if (!TextureImage[i]) return(1);

  // vytvorenie textur
  glBindTexture(GL_TEXTURE_2D,skybox_tex_id[i]);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_CLAMP);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_CLAMP);

  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_LINEAR);
  glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_LINEAR);

  glTexImage2D(GL_TEXTURE_2D,0,3,TextureImage[i]->w,TextureImage[i]->h,
               0,GL_BGR,GL_UNSIGNED_BYTE,TextureImage[i]->pixels);
 }

 // uvolnenie pouzitej pamate
 for (i=0;i<6;i++) {
  if (TextureImage[i]) SDL_FreeSurface(TextureImage[i]);
 }

 skybox_DL_id=glGenLists(1);
 glNewList(skybox_DL_id,GL_COMPILE);

 glScalef(3.0f,1.5f,3.0f);

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[0]);
 // predna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f(-1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f( 1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,0); glVertex3f( 1.0f, 1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f(-1.0f, 1.0f,-1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[1]);
 // zadna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f( 1.0f,-1.0f,1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,-1.0f,1.0f);
  glTexCoord2f(0,0); glVertex3f(-1.0f, 1.0f,1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f, 1.0f,1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[2]);
 // horna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(0,0); glVertex3f(-1.0f,-1.0f, 1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f,-1.0f, 1.0f);
  glTexCoord2f(1,1); glVertex3f( 1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,-1.0f,-1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[3]);
 // spodna stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(0,0); glVertex3f(-1.0f,1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f( 1.0f,1.0f,-1.0f);
  glTexCoord2f(1,1); glVertex3f( 1.0f,1.0f, 1.0f);
  glTexCoord2f(0,1); glVertex3f(-1.0f,1.0f, 1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[4]);
 // prava stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f( -1.0f,-1.0f, 1.0f);
  glTexCoord2f(0,1); glVertex3f( -1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,0); glVertex3f( -1.0f, 1.0f,-1.0f);
  glTexCoord2f(1,0); glVertex3f( -1.0f, 1.0f, 1.0f);
 glEnd();

 // zvolenie patricnej textury
 glBindTexture(GL_TEXTURE_2D,skybox_tex_id[5]);
 // lava stena
 glBegin(GL_TRIANGLE_FAN);
  glTexCoord2f(1,1); glVertex3f(1.0f,-1.0f,-1.0f);
  glTexCoord2f(0,1); glVertex3f(1.0f,-1.0f, 1.0f);
  glTexCoord2f(0,0); glVertex3f(1.0f, 1.0f, 1.0f);
  glTexCoord2f(1,0); glVertex3f(1.0f, 1.0f,-1.0f);
 glEnd();

 glEndList();

 return(0);
}

// vykreslenie skyboxu *****************************************************
void mObjects::obj_skybox_draw(void)
{
 // ulozenie potrebnych atributov
 glPushAttrib(GL_TEXTURE_BIT|GL_DEPTH_BUFFER_BIT|GL_LIGHTING_BIT);
 glEnable(GL_TEXTURE_2D);  // zapnutie texturovania
 glDisable(GL_DEPTH_TEST); // vypnutie testu hlbky
 glDisable(GL_LIGHTING);   // vypnutie osvetlenia

 glPushMatrix(); // ulozenie pohladovej matice

 glCallList(skybox_DL_id); // vykonanie prikazov ulozenych v displayliste

 glPopMatrix(); // vyber pohladovej matice

 glPopAttrib(); // obnova ulozenych atributov
}

// inicializacia kvadratickych objektov ************************************
int mObjects::obj_quadratic_init(void)
{
 obj_quad=gluNewQuadric();               // ukazatel na novy quadratic objekt
 gluQuadricNormals(obj_quad,GLU_SMOOTH); // vyhladene normalove vektory
 gluQuadricTexture(obj_quad,GL_TRUE);    // koordinaty textury

 return(0);
}

// vykreslenie kvadratickeho objektu ***************************************
void mObjects::obj_quadratic(GLuint type,GLfloat param,GLfloat color)
{
 // farba
 glColor4f(color,color,color,1.0f);

 // vyber objektu - gula, valec, ihlan, disk, vysec z disku
 switch (type) {
  case 0: gluSphere(obj_quad,param,32,32); break;
  case 1: gluCylinder(obj_quad,param/4.0f,param/4.0f,param,32,32); break;
  case 2: gluCylinder(obj_quad,param/4.0f,0.0f,param,32,32); break;
  case 3: gluDisk(obj_quad,param/4.0f,param,32,32); break;
  case 4: gluPartialDisk(obj_quad,param/4.0f,param,32,32,0.0f,180.0f); break;
  default: break;
 }
}
